/* BUILD_KEYBOARD.C
 * For use with GTKeyboard
 * Written by David Allen, s2mdalle@titan.vcu.edu
 * http://opop.nols.com/
 *
 * This file is distributable under the terms of the GNU General Public License
 * 
 * WARNING:  This is one of the nastiest pieces of code that I have ever
 * written, it's hard to understand, some of it is redundant, and it looks
 * like shit.  The good part is, IT WORKS.  I PROMISE I'll be cleaning this
 * up in the near future, because I can't STAND code that looks like this.
 * 
 * As of version 0.6 I've at least tried to explain what I did here.
 * The keypad code is almost identical to the keyboard code, just modified a
 * little bit so it doesn't draw numbers with their symbols on top of them,
 * and a few other things.
 */

#include "master.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <signal.h>
#include <ctype.h>
#include "cursor_foo.h"

/* Local defines for what keys appear as */
#define RIGHT_KEY                           "  -->  "
#define LEFT_KEY                            "  <--  "

/*
 * Check the notes at the bottom of the page for an ASCII drawing of how the
 * keyboard should look
 *
 * Each button is defined as a character string of two characters.  The first
 * is what you get when SHIFT || CAPS_LOCK > 0 and the second is the normal
 * key function.  This function loops through grabbing two characters at a
 * time and then calling makekeybutton to set things up and map the
 * callback to the key and so on.
 *
 * SPECIAL CASES WITHIN stuff[]:  (Yes it's braindamaged)
 * LL is the left cursor key
 * RR is the right cursor key
 * || is caps lock key
 * \\ (or escaped, it's \\\\) is SHIFT key
 *
*/

/* Global to this file */
static char keyb[]=
"`~1!2@3#4$5%6^7&8*9(0)-_=+\b\b\t\tqQwWeErRtTyYuUiIoOpP[{]}\\|||aAsSdDfFgGhHjJkKlL;:'\"\n\n\\\\zZxXcCvVbBnNmM,<.>/?\\\\  LLRR";

/* Keypad symbols with order buttons should be in */
/* Special symbols within keyp -> HH=Home EE=End DD=Delete NN=Num Lock.
 * Everything else is normal, except that some keys occur twice, doubling up
 * to fake double wide buttons without tables or any of that crap.  Works
 * on my machine fine, I hope that's generalizeable.
 */
static char keyp[]=
"HHEEDDNN//**--778899++445566++112233\n\n0000..\n\n";

GtkWidget *build_keyboard(GtkWidget *input)
{
     /* This function builds the entire keyboard. */

     int row_values[]={14, 14, 13, 12, 3};
     GtkWidget *rows[5];        /* The number of elements in row_values */
     GtkWidget *center[5];      /* Same as above - a center element for each */
     int x=0,y,z,w,r=0,temp=0;  /* Counters */

     /* Total number of buttons - should be all of the row_values added */
     GtkWidget *buttons[56];
     GtkWidget *container;     /* Entire keyboard to be returned */
     char buffer[2]="A\0";


     container = gtk_vbox_new(FALSE,0);

     /* Initialize all of the rows and centering elements */
     for(x=0; x<5; x++)
     {
	  rows[x] = gtk_hbox_new(FALSE, 0);
	  center[x]=gtk_alignment_new(0.5, 0.5, 0, 0);
     } /* End for */
     
     temp=0;
     z=0;
     w=0;
     for(x=0; x<5; x++) /* Rows */
     {
	  for(y=0; y<row_values[temp]; y++)  /* Buttons per row */
	  {
	       buffer[0] = keyb[2*r];
		
	       buffer[0] = toupper(buffer[0]);

	       buttons[w] = makekeybutton(keyb[2*r], (2*r), input,keyb);
	       gtk_box_pack_start(GTK_BOX(rows[x]), buttons[w], FALSE, FALSE,
				  0);
	       gtk_widget_show(buttons[w]);
	       w++; /* Button number */
	       r++; /* keyb subscript */
	  } /* End for */
	  temp++;
	  /* Pack each row into the main container */
     } /* End for */

     /* Pack each set of buttons into the container to be returned */
     for(x=0; x<5; x++)
     {
	  gtk_container_add(GTK_CONTAINER(center[x]), rows[x]);
	  gtk_box_pack_start(GTK_BOX(container), center[x], FALSE, FALSE, 0);
	  gtk_widget_show(rows[x]);
	  gtk_widget_show(center[x]);
     } /* End for */

#ifdef DEBUGGING
     fprintf(stderr,"Done building keyboard and returning\n");
     fflush(stderr);
#endif /* DEBUGGING */
     return(container);
} /* End build_keyboard */

/* This function takes a character, a subscript and so on, creates a button,
 * attaches the proper signals, (taking into account the special cases above)
 * and returns a ready-made button in the right place according to what
 * the variable keyb had at the subscript location.
 * Pretty braindamaged, huh?  :)
 */

GtkWidget *makekeybutton(char input, int subscript, GtkWidget *outwrite,
			 char foo[])
{
     char *temp = calloc(12, sizeof(char));
     char buffer[2]="A\0";
     GtkWidget *button;
     char *passing = calloc(3, sizeof(char));
     GtkWidget *arrow;

     buffer[0]=toupper(input);

     /* This gets passed to the callback as what the button does */
     sprintf(passing,"%c%c",foo[subscript],foo[subscript+1]);

     /* Handle special cases for the text of the button */
     if(input=='\t')
	  strcpy(temp,"  TAB  ");
     else if(input=='\n')
	  strcpy(temp," ENTER ");
     else if(input=='\b')
	  strcpy(temp,"BACKSPACE");
     else if(foo[subscript]=='|' && foo[subscript+1]=='|')
     {
#ifdef DEBUGGING	
	  fprintf(stderr,"CAPS??  Input=%c %c\n",foo[subscript],
		  foo[subscript+1]);
#endif
	  /* We've got a caps lock */
	  strcpy(temp," CAPS LOCK ");
     }
     else if(foo[subscript]=='L' && foo[subscript+1]=='L')
     {
#ifdef DEBUGGING
	  fprintf(stderr,"Left key?  Input=%c %c\n",foo[subscript],
		  foo[subscript+1]);
#endif /* DEBUGGING */
	  strcpy(temp,LEFT_KEY);      /* Left key cursor */
     } /* End else if */
     else if(foo[subscript]=='R' && foo[subscript+1]=='R')
     {
#ifdef DEBUGGING
	  fprintf(stderr,"Right key?  Input=%c %c\n",foo[subscript],
		  foo[subscript+1]);
#endif
	  strcpy(temp,RIGHT_KEY);
     } /* End else if */
     else if(foo[subscript]=='\\' && foo[subscript+1]=='\\')
     {
#ifdef DEBUGGING	  
	  fprintf(stderr,"SHIFT?  Input=%c %c\n",foo[subscript],
		  foo[subscript+1]);
#endif
	  /* We've got shift key */
	  strcpy(temp,"   SHIFT   ");
     } /* End else if */
     else if(input==' ')
     {
	  /* We need more space for this one to make it a big button */
	  g_free(temp);
	  temp = calloc(48, sizeof(char));
	  strcpy(temp,"                     SPACE                     ");
     }
     else if(isalpha(input))
     {
	  strcpy(temp,"  ");
	  strncat(temp,buffer,2);
	  strcat(temp,"  ");
     }
     else   /* Build keys that have two different symbols on them. */
     {
	  /* Print onto the button the shifted character, then the normal
	   * character below it 
	   */
	  sprintf(temp,"  %c  \n  %c  ",foo[subscript+1], foo[subscript]);
     }

     /* CAPS_LOCK needs to be a toggle button rather than normal */
     if(strstr(temp,"CAPS"))
	  button = gtk_toggle_button_new_with_label(temp);
     else if(strstr(temp,LEFT_KEY))
     {
	  arrow = gtk_arrow_new(GTK_ARROW_LEFT,GTK_SHADOW_OUT);
	  button = gtk_button_new();
	  gtk_container_add(GTK_CONTAINER(button), arrow);
	  gtk_widget_show(arrow);
     }
     else if(strstr(temp,RIGHT_KEY))
     {
	  arrow = gtk_arrow_new(GTK_ARROW_RIGHT,GTK_SHADOW_OUT);
	  button = gtk_button_new();
	  gtk_container_add(GTK_CONTAINER(button),arrow);
	  gtk_widget_show(arrow);
     }
     else
	  button = gtk_button_new_with_label(temp);

     /* Handle all the special cases when connecting signals to buttons */
     if(strstr(temp,"CAP"))
     {
	  gtk_signal_connect(GTK_OBJECT(button), "clicked",
			     GTK_SIGNAL_FUNC(capslock_toggle), outwrite);
     }
     else if(strstr(temp,"->"))
     {
	  gtk_signal_connect(GTK_OBJECT(button), "clicked",
			     GTK_SIGNAL_FUNC(cursor_right), NULL);
     }
     else if(strstr(temp,"<-"))
     {
	  gtk_signal_connect(GTK_OBJECT(button), "clicked",
			     GTK_SIGNAL_FUNC(cursor_left), NULL);
     }
     else if(strstr(temp,"SHIF"))
     {
	  gtk_signal_connect(GTK_OBJECT(button), "clicked",
			     GTK_SIGNAL_FUNC(shift_on), outwrite);
     }
     else
     {
	  gtk_signal_connect(GTK_OBJECT(button), "clicked", 
			     GTK_SIGNAL_FUNC(print_key), passing);
     }

     return(button);
}

/* NOTES:  This is what the keyboard should currently be looking like 
 *
 *  ` 1 2 3 4 5 6 7 8 9 0 - = \b 
 *  \t q w e r t y u i o p [ ] \
 * CAPS a s d f g h j k l ; ' \n
 * SHIFT z x c v b n m , . / SHIFT
 *          SPACE <-- -->
 */

GtkWidget *build_keypad(GtkWidget *input)
{
     int row_vals[]={3,4,4,4,4,4};
     GtkWidget *rows[6];
     GtkWidget *center[6];
     GtkWidget *buttons[24];
     GtkWidget *container;
     int x,y,z,r,w,temp;

     container = gtk_vbox_new(FALSE,0);

     for(x=0; x<5; x++)
     {
	  rows[x] = gtk_hbox_new(FALSE, 0);
	  center[x]=gtk_alignment_new(0,0, 0, 0);
     } /* End for */
     
     temp=0; x=0; z=0; w=0,r=0;

     for(x=0; x<5; x++) /* Rows */
     {
	  for(y=0; y<row_vals[temp]; y++)  /* Buttons per row */
	  {
	       buttons[w] = makekeypadkey(keyp[2*r], (2*r), input,keyp);
	       gtk_box_pack_start(GTK_BOX(rows[x]), buttons[w], FALSE, FALSE,
				  0);
	       gtk_widget_show(buttons[w]);
	       w++; /* Button number */
	       r++; /* keyp subscript */
	  } /* End for */
	  temp++;
	  /* Pack each row into the main container */
     } /* End for */

     /* Pack each set of buttons into the container to be returned */
     for(x=0; x<5; x++)
     {
	  gtk_container_add(GTK_CONTAINER(center[x]), rows[x]);
	  gtk_box_pack_start(GTK_BOX(container), center[x], FALSE, FALSE, 0);
	  gtk_widget_show(rows[x]);
	  gtk_widget_show(center[x]);
     } /* End for */

#ifdef DEBUGGING
     fprintf(stderr,"Done building keypad and returning\n");
     fflush(stderr);
#endif /* DEBUGGING */
     return(container);
} /* End build_keypad */

GtkWidget *makekeypadkey(char input, int subscript, GtkWidget *outwrite,
			 char foo[])
{
     char *temp = calloc(13, sizeof(char));
     char buffer[2]="A\0";
     GtkWidget *button;
     char *passing = calloc(3, sizeof(char));

     buffer[0]=toupper(input);

     /* This gets passed to the callback as what the button does */
     sprintf(passing,"%c%c",foo[subscript],foo[subscript+1]);

     /* Handle special cases for the text of the button */
     if(foo[subscript]=='N' && foo[subscript+1]=='N')
     {
	  strcpy(temp,"Num\nLck");
     } /* End else if */
     else if(foo[subscript]=='H' && foo[subscript+1]=='H')
     {
	  strcpy(temp,"Home\n    ");
     }
     else if(foo[subscript]=='E' && foo[subscript+1]=='E')
	  strcpy(temp,"End\n    ");
     else if(foo[subscript]=='D' && foo[subscript+1]=='D')
	  strcpy(temp,"Del\n    ");
     else if(foo[subscript]=='.')
     {
	  strcpy(temp,"  .   ");
     }
     else if(foo[subscript]=='\n')
     {
	  strcpy(temp,"RET");
     }
     else   /* Build keys that have two different symbols on them. */
     {
	  /* Print onto the button the shifted character, then the normal
	   * character below it 
	   */
	  sprintf(temp,"  %c  \n     ",foo[subscript]);
     }
     
     if(strstr(temp,"N"))
	  button = gtk_toggle_button_new_with_label(temp);
     else
	  button = gtk_button_new_with_label(temp);

     /* Handle all the special cases when connecting signals to buttons */
     if(strstr(temp,"N"))
     {
	  gtk_signal_connect(GTK_OBJECT(button), "clicked",
			     GTK_SIGNAL_FUNC(toggle_numlock), NULL);
     }
     else if(strstr(temp,"H"))
	  gtk_signal_connect(GTK_OBJECT(button), "clicked",
			     GTK_SIGNAL_FUNC(goto_bol), NULL);
     else if(strstr(temp,"E"))
	  gtk_signal_connect(GTK_OBJECT(button), "clicked",
			     GTK_SIGNAL_FUNC(goto_eol), NULL);
     else if(strstr(temp,"D"))
	  gtk_signal_connect(GTK_OBJECT(button), "clicked",
			     GTK_SIGNAL_FUNC(delete_key), output_text);
     else
	  gtk_signal_connect(GTK_OBJECT(button), "clicked", 
			     GTK_SIGNAL_FUNC(print_key), passing);

     return(button);
}

GtkWidget *build_cursorpad(GtkWidget *foo)
{
     GtkWidget *left, *right, *container, *h, *center;
     GtkWidget *subby;
     GtkWidget *arrows[2];

     if(!foo)
	  fprintf(stdout,"WARNING:  Build_cursorpad says !arg[0]\n");

     /* Make me 4 arrows, dammit. */
     arrows[0] = xpm_to_widget(foo, (gchar **)xpm_cursor_left);
     arrows[1] = xpm_to_widget(foo, (gchar **)xpm_cursor_right);

     center = gtk_alignment_new(0.5, 0.5, 0, 0);
     subby  = gtk_alignment_new(1, 1, 0, 0);
     container = gtk_vbox_new(FALSE,0);
     h = gtk_hbox_new(FALSE, 0);
     left = gtk_button_new();
     right = gtk_button_new();
     gtk_container_add(GTK_CONTAINER(left), arrows[0]);
     gtk_container_add(GTK_CONTAINER(right), arrows[1]);
     gtk_container_add(GTK_CONTAINER(center), h);
     gtk_box_pack_start(GTK_BOX(h), left, FALSE, FALSE, 0);
     gtk_box_pack_start(GTK_BOX(h), right, FALSE, FALSE, 0);
     gtk_box_pack_start(GTK_BOX(container), center, FALSE, FALSE, 0);

     gtk_signal_connect(GTK_OBJECT(left), "clicked",
			GTK_SIGNAL_FUNC(cursor_left), NULL);
     gtk_signal_connect(GTK_OBJECT(right), "clicked",
			GTK_SIGNAL_FUNC(cursor_right), NULL);

     gtk_widget_show(left); gtk_widget_show(right);
     gtk_widget_show(h);
     gtk_widget_show(center); gtk_widget_show(container); 
     
     gtk_container_add(GTK_CONTAINER(subby), container);
     return(subby);
}

GtkWidget *build_fkeys(void)
{
     GtkWidget *buttons[16];
     int x=0;
     char *foobar=calloc(10, sizeof(char));
     char *tmp[14];
     GtkWidget *container = gtk_hbox_new(FALSE, 0);

     buttons[0]=gtk_button_new_with_label("ESC ");
     gtk_signal_connect(GTK_OBJECT(buttons[0]), "clicked",
			GTK_SIGNAL_FUNC(not_done_yet), NULL);

     for(x=0; x<14; x++)
	  tmp[x]=calloc(4,sizeof(char));
     for(x=1; x<13; x++)
     {
	  sprintf(foobar," F%d ",x);
	  sprintf(tmp[x],"F%d",x);
	  buttons[x]=gtk_button_new_with_label(foobar);
	  /* Really cheesy signal - just print the name of the key to the
	   * screen
	   */
	  gtk_signal_connect(GTK_OBJECT(buttons[x]), "clicked",
			     GTK_SIGNAL_FUNC(display_key), tmp[x]);
     } /* End for */
     
     buttons[13]=gtk_button_new_with_label("Print\nScreen");
     buttons[14]=gtk_button_new_with_label("Scroll\nLock");
     buttons[15]=gtk_button_new_with_label("Pause\nBreak");

     gtk_signal_connect(GTK_OBJECT(buttons[13]), "clicked",
			GTK_SIGNAL_FUNC(display_key), "Print Screen");
     gtk_signal_connect(GTK_OBJECT(buttons[14]), "clicked",
			GTK_SIGNAL_FUNC(display_key), "Scroll Lock");
     gtk_signal_connect(GTK_OBJECT(buttons[15]), "clicked",
			GTK_SIGNAL_FUNC(display_key), "Pause/Break");

     for(x=0; x<16; x++)
     {
	  gtk_box_pack_start(GTK_BOX(container), buttons[x], FALSE, FALSE, 0);
	  gtk_widget_show(buttons[x]);
     } /* End for */

     return(container);
}

/* EOF */
