/* HTML_MODE.C
 * For use with GTKeyboard
 * This is a crude version of a quick html tag inserter.
 * Right now all of these functions are included in the item factory that 
 * makes the menu - I'll have to eventually build in submenus and so on,
 * but so far it's pretty small...
 * 
 * In order for all of these to be used, you have to have INCLUDE_HTML 
 * defined within master.h - otherwise they won't be compiled in.  Well, they
 * will be compiled in but they won't be used.
 */

#include "master.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <signal.h>
#include <ctype.h>

#define HTML_MODE_C

#ifdef INCLUDE_HTML
void html_header(GtkWidget *w, int data)
{
     char *close="</H1>";
     freezeit();
     switch(data)
     {
     case H1: vanilla("<H1>");
	  vanilla("</H1>");
	  cursor_left_x_times(strlen(close));
	  break;
     case H2: vanilla("<H2>");
	  vanilla("</H2>");
	  cursor_left_x_times(strlen(close));
	  break;
     case H3: vanilla("<H3>");
	  vanilla("</H3>");
	  cursor_left_x_times(strlen(close));
	  break;
     case H4: vanilla("<H4>");
	  vanilla("</H4>");
	  cursor_left_x_times(strlen(close));
	  break;
     case H5: vanilla("<H5>");
	  vanilla("</H5>");
	  cursor_left_x_times(strlen(close));
	  break;
     case H6: vanilla("<H6>");
	  vanilla("</H6>");
	  cursor_left_x_times(strlen(close));
	  break;
     default:
	  vanilla("Oops.  Bad arg to html_header.  Please report as a bug.\n");
	  break;

     } /* End switch */

     thawit();
} /* End html_header */

void html_comment(void)
{
     char *close=" ->";
     int x;
     FREEZE(output_text);
     vanilla("<!-- ");
     vanilla(close);
     for(x=0; x<strlen(close); x++)
	  cursor_left();
     thawit();
}

void html_doctype(void)
{
     freezeit();
     vanilla("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">\n");
     thawit();
}

void html_table(void)
{
     char *close="</TABLE>\n";
     int x;
     freezeit();
     vanilla("<TABLE>\n");
     vanilla(close);
     for(x=0; x<strlen(close); x++)
	  cursor_left();
     thawit();
}

void html_pre(void)
{
     char *close="</PRE>";
     int x;
     freezeit();
     vanilla("<PRE>\n");
     vanilla(close);
     for(x=0; x<strlen(close); x++)
	  cursor_left();
}

void html_table_row(void)
{
     char *close="</TR>";
     int x;
     freezeit();
     vanilla("<TR>\n");
     vanilla(close);
     for(x=0; x<strlen(close); x++)
	  cursor_left();
     thawit();
}

void html_table_data(void)
{
     char *close="</TD>";
     int x;
     freezeit();
     vanilla("<TD>");
     vanilla(close);
     for(x=0; x<strlen(close); x++)
	  cursor_left();
     thawit();
}

void html_paragraph(void)
{
     freezeit();
     vanilla("<P>");
     thawit();
}

void html_list(void)
{
     char *list="<UL>\n";
     char *list1="\n</UL>";
     int x;
     freezeit();
     vanilla(list);
     vanilla(list1);
     for(x=0; x<strlen(list1); x++)
	  cursor_left();
     thawit();
}

void html_list_item(void)
{
     freezeit();
     vanilla("<LI>");
     thawit();
}

void html_linebreak(void)
{
     freezeit();
     vanilla("<BR>");
     thawit();
}

void html_hr(void)
{
     freezeit();
     vanilla("<HR>");
     thawit();
}

void html_http(void)
{
     freezeit();
     vanilla("http://");
     thawit();
}

void html_mailto(void)
{
     freezeit();
     vanilla("mailto:");
     thawit();
}

void html_news(void)
{
     freezeit();
     vanilla("news:");
     thawit();
}

void html_telnet(void)
{
     freezeit();
     vanilla("telnet://");
     thawit();
}

void html_gopher(void)
{
     freezeit();
     vanilla("gopher://");
     thawit();
}

void html_ftp(void)
{
     freezeit();
     vanilla("ftp://");
     thawit();
}

void html_bold(void)
{
     char *bold="<B>";
     char *bold1="</B>";
     int x=0;
     freezeit();
     vanilla(bold);
     vanilla(bold1);
     for(x=0; x<4; x++)
     {
	  cursor_left();
     }
     thawit();
}

void html_strong(void)
{
     char *strong="<STRONG>";
     char *strong1="</STRONG>";
     int x=0;
     freezeit();
     vanilla(strong);
     vanilla(strong1);
     for(x=0; x<strlen(strong1); x++)
	  cursor_left();
     thawit();
}

void html_italics(void)
{
     char *it="<I>";
     char *it1="</I>";
     int x=0;
     freezeit();
     vanilla(it);
     vanilla(it1);
     for(x=0; x<strlen(it1); x++)
	  cursor_left();
     thawit();
}

void html_center(void)
{
     char *center="<CENTER>";
     char *center1="</CENTER>";
     int x;
     freezeit();
     vanilla(center);
     vanilla(center1);
     for(x=0; x<strlen(center1); x++)
	  cursor_left();
     thawit();
}

void html_image(void)
{
     char *img="<IMG SRC=\"\">";
     freezeit();
     vanilla(img);
     cursor_left();
     cursor_left();
     cursor_left();
     thawit();
}

void html_link(void)
{
     char *link="<A HREF=\"\"></A>";
     int x=0;
     freezeit();
     vanilla(link);
     /* Move back 6 spaces to start typing in link target location */
     for(x=0; x<6; x++)
	  cursor_left();
     thawit();
}

void html_html(void)
{
     char *html="<HTML>\n";
     freezeit();
     vanilla(html);
     thawit();
}

void html_html_close(void)
{
     freezeit();
     vanilla("\n</HTML>");
     thawit();
}

void html_body(void)
{
     freezeit();
     vanilla("<BODY>\n");
     thawit();
}

void html_head(void)
{
     freezeit();
     vanilla("<HEAD>\n");
     thawit();
}

void html_head_close(void)
{
     freezeit();
     vanilla("</HEAD>\n");
     thawit();
}

void html_title(void)
{
     char *close="</TITLE>";
     int x;
     freezeit();
     vanilla("<TITLE>");
     for(x=0; x<strlen(close); x++)
	  cursor_left();
     thawit();
}

void html_body_close(void)
{
     freezeit();
     vanilla("</BODY>\n");
     thawit();
}

void html_template(void)
{
     char *one="<HTML>\n<HEAD>\n<TITLE>";
     char *two="Insert your title here</TITLE></HEAD>\n<BODY><P>Document\n</BODY>\n</HTML>\n\n";
     int x;

     freezeit();
     vanilla(one);
     vanilla(two);
     for(x=0; x<strlen(two); x++)
	  cursor_left();
     thawit();
} /* End html_template */

#endif /* INCLUDE_HTML */

/* Inserts the text input into output_text widget */
/* Yeah the function name is weird, but I just couldn't stop thinking about
 * plain vanilla text, as in, no colors, no weird fonts, etc.
 */

void vanilla(char *input)
{
#ifdef TEMP_DEBUGGING
     fprintf(stdout,"Printing %s to output_text in vanilla\n",input);
#endif
     gtk_text_insert(GTK_TEXT(output_text), NULL, NULL, NULL,
		     input, strlen(input));
     
     gtk_editable_set_position(GTK_EDITABLE(output_text),
			       gtk_text_get_point(GTK_TEXT(output_text)));

}

void chocolate(char *input)
{
#ifdef TEMP_DEBUGGING
     fprintf(stdout,"Printing %s to status in chocolate\n",input);
#endif
     gtk_text_insert(GTK_TEXT(status), NULL, NULL, NULL,
		     input, strlen(input));
} /* End chocolate */

/* EOF */

