/* MISC_CURSOR.C
 * For use with GTKeyboard
 * Written by David Allen, s2mdalle@titan.vcu.edu
 * http://opop.nols.com/
 * 
 * This file is distributable under the terms of the GNU General Public License
 *
 * This file just does some basic cursor movement, nothing fancy - haven't
 * finished up and down yet because the way I currently figure it, it's going
 * to depend on how many characters/line in the text widget which could be
 * changing size...so I'll do that a bit down the line
 */

#include "master.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <signal.h>
#include <ctype.h>

#define VLINE 87

gint XSIZE=0;
gint YSIZE=0;

void toggle_numlock(void)
{
     if(options.NUMLOCK)
     {
	  options.NUMLOCK=0;
	  chocolate("NUMLOCK is OFF\n");
     }
     else
     {
	  options.NUMLOCK=1;
	  chocolate("NUMLOCK is ON\n");
     }
} /* End toggle_numlock */

void toggle_wordwrap(void)
{
     if(options.WORD_WRAP)
     {
	  options.WORD_WRAP=0;
	  gtk_text_set_word_wrap(GTK_TEXT(output_text), FALSE);
     }
     else
     {
	  options.WORD_WRAP=1;
	  gtk_text_set_word_wrap(GTK_TEXT(output_text), TRUE);
     }
}

/* I think this is going to fix the buglet about the cursor showing up in the
 * wrong position all the time
 */
void update_cursor(void)
{
/*     char *bkspc="\b\b\0";
     char *spc  ="  \0";
*/
     
     /* Need to find a way to update the cursor via GtkText->cursor_pos_x
      * and GtkText->cursor_pos_y
      * So this isn't doing anything right now. 
      */

/*     print_key((GtkWidget *)NULL, spc);
     print_key((GtkWidget *)NULL, bkspc); */
} /* End update_cursor */

void cursor_left(void)
{
     int pos = gtk_text_get_point(GTK_TEXT(output_text));
     char *left = "CursorLeft ";
     
     gtk_text_freeze(GTK_TEXT(output_text));
     /* Bounds checking on setting the point */
     if(pos > 0)
     {
	  gtk_text_set_point(GTK_TEXT(output_text), (pos-1));
     }
     gtk_text_thaw(GTK_TEXT(output_text));

     chocolate(left);
} /* End cursor left */

void cursor_up(void)
{
/*     gint x=gtk_text_get_point(GTK_TEXT(output_text));
     if((x-VLINE)>=0)
	  gtk_text_set_point(GTK_TEXT(output_text), (x-VLINE));
     else
	  chocolate("Can't move up by one line.\n");
*/
}

void setup_vals(void)
{
     GtkText *foo=GTK_TEXT(output_text);
     int x=foo->cursor_pos_x;
     int y=foo->cursor_pos_y;
     
     FREEZE(output_text);
     vanilla("\n ");
     XSIZE=foo->cursor_pos_x-x;
     YSIZE=foo->cursor_pos_y-y;
     
     fprintf(stderr,"XSIZE=%d  YSIZE=%d\n",XSIZE,YSIZE);
     gtk_text_backward_delete(GTK_TEXT(output_text),strlen("\n "));
     THAW(output_text);
}

void cursor_right(void)
{
     int pos = gtk_text_get_point(GTK_TEXT(output_text));
     int l=gtk_text_get_length(GTK_TEXT(output_text));
     char *right = "CursorRight ";
     ++pos;

     gtk_text_freeze(GTK_TEXT(output_text));
     if(pos<=l)	  
	  gtk_text_set_point(GTK_TEXT(output_text), pos);

     /* If position is already at the end of the file, don't do anything
      * because if you do GTK spouts a message and we don't want that, now
      * do we?
      */
     gtk_text_thaw(GTK_TEXT(output_text));

     gtk_text_insert(GTK_TEXT(status), NULL, NULL, NULL, right, strlen(right));
} /* End cursor_right */

void cursor_left_x_times(size_t input)
{
     register int y=0;
     for(y=0; y<input; y++)
	  cursor_left();
}

void cursor_right_x_times(size_t input)
{
     register int y=0;
     for(y=0; y<input; y++)
	  cursor_right();
}

/* Had to write these silly functions because itemfactories won't let you use
 * macros in them.
 */
void goto_eof(void)
{
     gtk_text_set_point(GTK_TEXT(output_text), 
			gtk_text_get_length(GTK_TEXT(output_text)));
}

void goto_bof(void)
{
     gtk_text_set_point(GTK_TEXT(output_text), 0);
}

void goto_eol(void)
{
     int x = gtk_text_get_point(GTK_TEXT(output_text));
     int y = gtk_text_get_length(GTK_TEXT(output_text));
     char *foobar=calloc(2, sizeof(char));
     
     /* Keep advancing while we dont have a linebreak/CR or we're not at the
      * end of the file
      */
     if(y>0 && x<y)
     {
	  while(*foobar!='\n' && *foobar!='\r' && x<y)
	  {
	       /* Get one character */
	       foobar = gtk_editable_get_chars(GTK_EDITABLE(output_text),
					       (gint) x, (gint)(x+1));
	       x++;
	  }
	  
	  if(*foobar=='\n')
	       --x;  
	  /* Otherwise it's a normal char that we want to be behind */

	  /* Set the point to the end if it's a valid value */
	  if(x<=y)
	  {
	       freezeit();
	       gtk_text_set_point(GTK_TEXT(output_text),x);
	       thawit();
	  }
	  else
	       chocolate("Cursor set to end of file - no end of line found\n");
     } /* End else */
     else 
     {
	  chocolate("Can't go to the end of this line.\n");
     }
#ifdef TEMP_DEBUGGING
     fprintf(stderr,"X was %d\n",x);
     fflush(stderr);
#endif
} /* end goto_eol */

void goto_bol(void)
{
    gint x = gtk_text_get_point(GTK_TEXT(output_text));
    gint y = gtk_text_get_length(GTK_TEXT(output_text));
    gchar *foobar="I'm initialized!  Rock on, or something.";

    /* Keep advancing while we dont have a linebreak/CR or we're not at the
     * end of the file
     */

#ifdef DEBUGGING
    fprintf(stderr,"x=%d y=%d\n",x,y);
#endif

    if(x<=0)
    {
	 chocolate("Can't go to beginning of line.\n");
    }
    else
    {
	 while(*foobar!='\n' && *foobar!='\r' && x>0 && x<=y)
	 {
	      /* Get one character */
	      foobar=gtk_editable_get_chars(GTK_EDITABLE(output_text),
					      (gint) (x-1), (gint)(x));
	      x--;
#ifdef DEBUGGING	      
	      fprintf(stderr,"Loopy %s\n",foobar);   fflush(stderr);	
	      fprintf(stderr,"    x = %d  ",x);   fflush(stderr);
#endif /* DEBUGGING */
	 }
	 
	 /* If we ended on a linebreak, go after not before */
	 if(*foobar=='\n' || *foobar=='\r')
	      x++;

	 /* Set the point to the end if it's a valid value */
	 if(x>=0 && x<=y)
	 {
	      freezeit();
#ifdef DEBUGGING
	      fprintf(stderr,"Setting with x=%d\n",x);  fflush(stderr);
#endif /* DEBUGGING */
	      gtk_text_set_point(GTK_TEXT(output_text),x);
	      thawit();
	 }
	 else
	      chocolate("Cursor not set - no last line end found.\n");
    } /* End else */
#ifdef TEMP_DEBUGGING
    fprintf(stderr,"X was %d\n",x);
    fflush(stderr);
#endif
} /* End goto_bol */

void freezeit(void)
{
     gtk_text_freeze(GTK_TEXT(output_text));
}

void thawit(void)
{
     gtk_text_thaw(GTK_TEXT(output_text));
     update_cursor();  /* Replace cursor spot? */
}

/* Works just like the DEL key */
void delete_key(GtkWidget *w, gpointer data)
{
     gint y = gtk_text_get_point(GTK_TEXT((GtkWidget *)data));
     gtk_editable_delete_text(GTK_EDITABLE((GtkWidget *)data), y, y+1);
}


