/* SHORTCUTS.C
 * For use with GTKeyboard
 * written by David Allen
 * s2mdalle@titan.vcu.edu http://opop.nols.com/
 * 
 * This file is distributable under the terms of the GNU General Public License
 *
 * This is just a collection of shortcuts that will end up in a menu to make
 * typing faster
 *
 * The SC_ in the function names is for shortcut.
 *
 */

#include "master.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <sys/time.h>

#define SHORTCUTS_C

/* Functions - makes heavy use of vanilla defined in html_mode.c */
/* These should be functions rather than macros so they can be included
 * in the item factories - otherwise not constant complaints from gcc
 */

void SC_timestamp(void)
{
     time_t now;
     struct tm *ptr;
     char sucka[40];
     char *ptr2;
     
     ptr2=&sucka[0];
     
     time(&now);
     ptr=localtime(&now);
     ptr2=asctime(ptr);
     
     freezeit();

#ifdef TEMP_DEBUGGING
     fprintf(stderr,"Inserting timestamp %s\n",ptr2);
     fflush(stderr);
#endif
     vanilla(ptr2);
     vanilla("\n");
     thawit();
}

void SC_rose(void)
{
     freezeit();
     vanilla(" @}-'-,- ");
     thawit();
}

void SC_angle(void)
{
     freezeit();
     vanilla("<>");
     cursor_left();
     thawit();
}

void SC_double_angle(void)
{
     freezeit();
     vanilla("<<>>");
     cursor_left();
     cursor_left();
     thawit();
}

void SC_paragraph(void)
{
     freezeit();
     vanilla("\n\n\t");
     thawit();
}

void SC_hihat(void)
{
     freezeit();
     vanilla("^^");
     cursor_left();
     thawit();
}

void SC_smiley(void)
{
     freezeit();
     vanilla(":)");
     thawit();
}

void SC_winky(void)
{
     freezeit();
     vanilla(";)");
     thawit();
}

void SC_quote(void)
{
     freezeit();
     vanilla("\"\"");
     cursor_left();
     thawit();
}

void SC_single_quote(void)
{
     freezeit();
     vanilla("''");
     cursor_left();
     thawit();
}

void SC_book_quote(void)
{
     freezeit();
     vanilla("`'");
     cursor_left();
     thawit();
}

void SC_backquote(void)
{
     freezeit();
     vanilla("``");
     cursor_left();
     thawit();
}

void SC_pseudo_underline(void)
{
     freezeit();
     vanilla("__");
     cursor_left();
     thawit();
}

void SC_emphasize(void)
{
     freezeit();
     vanilla("**");
     cursor_left();
     thawit();
}

void SC_surround(void)
{
     char *sur="--==";
     char *sur2="==--";
     int x;
     
     freezeit();
     vanilla(sur);
     vanilla(sur2);
     for(x=0; x<strlen(sur2); x++)
	  cursor_left();
     thawit();
}

void SC_parens(void)
{
     freezeit();
     vanilla("()");
     cursor_left();
     thawit();
}

/* EOF */
