/* TRULY_MISC.C
 * Written by David Allen
 * s2mdalle@titan.vcu.edu
 * http://opop.nols.com/
 *
 * Distributed under the GNU GPL.
 *
 * This is the place for all the things I couldn't figure out where to put. :)
 *
 * Thanks to the GTK tutorial for this function xpm_to_widget
 */

#define TRULY_MISC_C
#include "master.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <signal.h>
#include <ctype.h>
#include "splash.h"

#define TEMP_DEBUGGING

extern GtkWidget *window;

GtkWidget *xpm_to_widget(GtkWidget *foo, gchar **xpm_data)
{
     /* GtkWidget is the storage type for widgets */
     GtkWidget *pixmapwid;
     GdkPixmap *pixmap;
     GdkBitmap *mask;
     GtkStyle *style;

     style = gtk_widget_get_style(foo);

     fprintf(stderr,"%s",(char *)window->window);

     pixmap = gdk_pixmap_create_from_xpm_d(window->window,  &mask,
					   &style->bg[GTK_STATE_NORMAL],
					   (gchar **)xpm_data );
     
     /* a pixmap widget to contain the pixmap */
     pixmapwid = gtk_pixmap_new(pixmap, mask);
     gtk_widget_show(pixmapwid);
     
     return(pixmapwid);
} /* End xpm_to_widget */

void splash(void)
{
     GtkWidget *window, *button;
     GtkWidget *foo;

     window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
     gtk_widget_set_usize(window, 310, 119);
     gtk_window_set_title(GTK_WINDOW(window), "GTKeyboard");
     gtk_signal_connect(GTK_OBJECT(window), "delete_event",
			GTK_SIGNAL_FUNC(gtk_widget_destroy), window);
     foo = xpm_to_widget(window, (gchar **)splash_xpm);
     button = gtk_button_new();
     gtk_container_add(GTK_CONTAINER(button), foo);
     gtk_signal_connect(GTK_OBJECT(button), "clicked",
			GTK_SIGNAL_FUNC(smack), window);
     gtk_widget_show(foo);
     gtk_widget_show(button);
     gtk_widget_show(window);
     gtk_container_add(GTK_CONTAINER(window), button);

     gtk_widget_show_all(window);
} /* End splash */

void not_done_yet(void)
{
     GtkWidget *window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
     GtkWidget *label, *button, *vbox;

     vbox = gtk_vbox_new(FALSE,0);
     label = gtk_label_new("Sorry, this isn't implemented yet.");
     button = gtk_button_new_with_label("Close");
     
     gtk_signal_connect(GTK_OBJECT(button), "clicked",
			GTK_SIGNAL_FUNC(smack), window);
     gtk_signal_connect(GTK_OBJECT(window), "delete_event",
			GTK_SIGNAL_FUNC(gtk_widget_destroy), window);
     gtk_box_pack_start(GTK_BOX(vbox),label, FALSE, FALSE, 0);
     gtk_box_pack_start(GTK_BOX(vbox),button,FALSE, FALSE, 0);
     gtk_container_add(GTK_CONTAINER(window), vbox);

     gtk_widget_show(button);
     gtk_widget_show(label);
     gtk_widget_show(vbox);
     gtk_widget_show(window);

     gtk_widget_show_all(window);
} /* End not_done_yet */
